/*
import 'package:flutter/cupertino.dart';
import 'package:provider/provider.dart';
import 'package:provider/single_child_widget.dart';

typedef ShouldRebuild<A, T> = bool Function(A notifier, T value);

class ItemRefresher<A, T> extends SingleChildStatefulWidget {
  final ShouldRebuild<A, T>? _shouldRebuild;
  final T value;
  final ValueWidgetBuilder<T> builder;

  ItemRefresher({
    Key? key,
    required this.value,
    required this.builder,
    ShouldRebuild<A, T>? shouldRebuild,
    Widget? child,
  })  : assert(builder != null),
        this._shouldRebuild = shouldRebuild,
        super(key: key, child: child);


  @override
  _ItemRefresherState<A, T> createState() => _ItemRefresherState<A, T>();
}

class _ItemRefresherState<A, T> extends SingleChildState<ItemRefresher<A, T>> {
  Widget? cache;
  Widget? oldWidget;

  @override
  Widget buildWithChild(BuildContext context, Widget? child) {
    A notifier = Provider.of(context);
    var shouldInvalidateCache = oldWidget != widget || (widget._shouldRebuild != null && notifier != null && widget._shouldRebuild?.call(notifier, widget.value) == true);
    if (shouldInvalidateCache) {
      oldWidget = widget;
      cache = widget.builder(context, widget.value, child);
    }
    //todo null-safe??
    return cache??widget;
  }
}
*/
